﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5
@EndOfDesignText@
Sub Class_Globals
	Private btn(3) As Button
	Private pnlBG,pnlSelect As Panel
	
	Private Result As Int
	Private ModuleName As Object
	Private EventName As String
	Private AW, AH As Int
	
	Private txtInput As TextField
	
	Private clvSelect As CustomListView
End Sub

Public Sub Initialize(Module As Object, Event As String, Pg As Page)
	If pnlBG.IsInitialized Then Return
	
	AW = Pg.RootPanel.Width
	AH = Pg.RootPanel.Height
	
	'Log("Height " & AH & " : Width " & AW)
	ModuleName = Module
	EventName = Event
	
	pnlBG.Initialize("pnlBG")

	pnlBG.Color = Colors.ARGB(150, 36, 36, 36)
	pnlBG.BringToFront
	Pg.RootPanel.AddView(pnlBG, 0, 0, AW,AH)
	
	pnlSelect.Initialize("pnlSelect")
	pnlSelect.Color = Colors.White
	
	For i = 0 To 2
		btn(i).Initialize("Button", btn(i).STYLE_SYSTEM)
		btn(i).Color = Colors.White
		btn(i).CustomLabel.TextColor = Colors.Black
		btn(i).CustomLabel.TextAlignment = btn(i).CustomLabel.ALIGNMENT_CENTER
		btn(i).CustomLabel.AdjustFontSizeToFit = True
		btn(i).CustomLabel.Font = Font.CreateNew(15)
		btn(i).Height = 50dip
		btn(i).Visible = False
		btn(i).Tag = i
	Next
	
End Sub


Private Sub Button_Down
	Dim b As Button
	b = Sender
	b.Color = Colors.LightGray
End Sub

Private Sub Button_Up
	Dim b As Button
	b = Sender
	b.Color = Colors.White
End Sub

Private Sub pnlBG_Click
	Result = 0
	pnlBG.RemoveViewFromParent
	CallSub3(ModuleName, EventName & "_results", Result, "")
End Sub

Private Sub pnlSelect_Click
	'Do nothing
End Sub

Private Sub SetHeader(Header As String) As Int
	Dim lbl As Label: lbl.Initialize("")
	Dim lLine As Label: lLine.Initialize("")
	
	
	lbl.Text = Header
	lbl.TextColor = Colors.RGB(68, 165, 231)
	lbl.TextAlignment = lbl.ALIGNMENT_LEFT
	lbl.Font = Font.CreateNew(19)
	pnlSelect.AddView(lbl, 10dip, 5dip, AW - 20dip, 40dip)

	lLine.Color = Colors.RGB(68, 165, 231)
	pnlSelect.AddView(lLine, 0dip, 49dip, AW, 1dip)
	
	Return 50dip
End Sub

Private Sub SetButton(lHeight As Int, Button1 As String, Button2 As String, Button3 As String) As Int
	Dim iBtn As Int
	
	iBtn = 0
	If Button1 <> "" Then
		btn(0).Text = Button1
		btn(0).Visible = True
		iBtn = 1
	End If
	If Button2 <> "" Then
		btn(1).Text = Button2
		btn(1).Visible = True
		iBtn = iBtn + 1
	End If
	If Button3 <> "" Then
		btn(2).Text = Button3
		btn(2).Visible = True
		iBtn = iBtn + 1
	End If
	
	btn(0).Width = AW / iBtn
	btn(1).Width = AW / iBtn
	btn(2).Width = AW / iBtn
	
	
	lHeight = lHeight + 50dip
	pnlSelect.Height = lHeight
	
	If Button1 <> "" Then
		pnlSelect.AddView(btn(0), 0, pnlSelect.Height - 50dip, btn(0).Width, 50dip)
	End If
	
	If Button2 <> "" Then
		pnlSelect.AddView(btn(1), btn(0).Width, pnlSelect.Height - 50dip, btn(1).Width, 50dip)
	End If
	
	If Button3 <> "" Then
		pnlSelect.AddView(btn(2), btn(1).Left + btn(1).Width, pnlSelect.Height - 50dip, btn(2).Width, 50dip)
	End If
	
	Return lHeight

	
End Sub

Private Sub SetInputText(lHeight As Int, DefValue As String, Hint As String) As Int
	Dim lH As Int
	
	txtInput.Initialize("txtInput")
	txtInput.TextColor = Colors.Black
	txtInput.HintText = Hint
	txtInput.Font = Font.CreateNew(15)
	txtInput.Text = DefValue
	If AW > AH Then
		lH = lHeight + 100dip
		pnlSelect.AddView(txtInput, 10dip, lHeight + 30dip, AW - 20dip, 40dip)
	Else
		lH = lHeight + 180dip
		pnlSelect.AddView(txtInput, 10dip, lHeight + 70dip, AW - 20dip, 40dip)
	End If
	Return lH
End Sub

Private Sub SetListText(lHeight As Int, Lst As List) As Int
	Dim lH As Int
	Dim p As Panel: p.Initialize("")
	
	For i = 0 To Lst.Size - 1
		Dim m As Map: m.Initialize
		m = Lst.Get(i)
		lH = lH + 50dip
	Next
	
	If AW > AH Then
		If lH >= 200dip Then
			lH = 200dip
		End If
	Else
		If lH >= 300dip Then
			lH = 300dip
		End If
	End If
	
	Dim p As Panel: p.Initialize("")
	pnlSelect.AddView(p, 0dip, lHeight, AW, lH)
	p.LoadLayout("clv")
	
	For i = 0 To Lst.Size - 1
		Dim m As Map: m.initialize
		m = Lst.Get(i)
		
		Dim Pnl As Panel = AddDlgSelection(Null, m.Get("Display"))
		clvSelect.Add(Pnl, m)
	Next
	
	
	Return lH + lHeight
End Sub


Private Sub AddDlgSelection(bitmap As Bitmap, Value As String) As Panel
	Dim p As Panel: P.Initialize("")
	
	p.Width = AW
	p.Color = Colors.White
	
	'If bitmap <> Null Then
	'End If
	
	Dim l As Label: l.initialize("")
	l.Font = Font.CreateNew(15)
	l.TextColor = Colors.Black
	l.Text = Value
	l.TextAlignment = l.ALIGNMENT_LEFT
	l.Width = AW - 20dip
	l.Height = 50dip
	'l.Color = Colors.Red
	p.Height = 50dip
	p.AddView(l, 10dip, 0, AW - 20dip, l.Height)
	
	'Add Line
	Dim line As Label: line.initialize("")
	line.Color = Colors.LightGray
	p.AddView(line, 10dip, p.Height - 2dip, AW - 20dip, 1dip)
	
	Return p
End Sub

Public Sub GetInputText(DefValue As String, Hint As String, Header As String, Button1 As String, Button2 As String, Button3 As String)
	Dim lHeight As Int
	
	lHeight = SetHeader(Header)
	lHeight = SetInputText(lHeight, DefValue, Hint)
	lHeight = SetButton(lHeight, Button1, Button2, Button3)
	
	pnlBG.AddView(pnlSelect, 0dip, pnlBG.Height, pnlBG.Width, lHeight)
	pnlSelect.SetLayoutAnimated(350, 1, 0,AH - lHeight, AW, lHeight)
	
	
	Wait for Button_Click
	Dim B As Button
	B = Sender
	Result = B.Tag
	pnlBG.RemoveViewFromParent
	
	If txtInput.Text.Trim = "" Then Result = 0
	CallSub3(ModuleName, EventName & "_results", Result, txtInput.Text)
End Sub

Public Sub GetListText(Header As String, Lst As List, Button1 As String, Button2 As String, Button3 As String)
	Dim lHeight As Int
	
	lHeight = SetHeader(Header)
	lHeight = SetListText(lHeight, Lst)
	
	If Button1 <> "" Then
		lHeight = SetButton(lHeight, Button1, Button2, Button3)
	End If
	

	
	pnlBG.AddView(pnlSelect, 0dip, pnlBG.Height, pnlBG.Width, lHeight)
	pnlSelect.SetLayoutAnimated(350, 1, 0,AH - lHeight, AW, lHeight)
	
End Sub

Private Sub Button_Click
	Dim B As Button
	B = Sender
	Result = B.Tag
	pnlBG.RemoveViewFromParent
	CallSub3(ModuleName, EventName & "_results", Result, "")
End Sub


Sub clvSelect_ItemClick (Index As Int, Value As Object)
	
	Result = 1
	pnlBG.RemoveViewFromParent

	CallSub3(ModuleName, EventName & "_results", Result, Value)
		
End Sub